unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, FileCtrl, ShellCtrls, ShellAPI, ShlObj,
  XPMan,ActiveX, OleCtrls, SHDocVw;



type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    Label3: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button5: TButton;
    Panel2: TPanel;
    Button4: TButton;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Label4: TLabel;
    Label5: TLabel;
    Panel3: TPanel;
    DirectoryListBox1: TDirectoryListBox;
    Panel4: TPanel;
    FilterComboBox1: TFilterComboBox;
    Panel5: TPanel;
    DriveComboBox1: TDriveComboBox;
    Panel6: TPanel;
    FileListBox3: TFileListBox;
    Panel7: TPanel;
    Edit3: TEdit;
    Label6: TLabel;
    Button6: TButton;
    Button7: TButton;
    XPManifest1: TXPManifest;
    Edit4: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit5: TEdit;
    Button8: TButton;
    Button9: TButton;
    Edit6: TEdit;
    WebBrowser1: TWebBrowser;
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Edit6KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button9Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button4Click(Sender: TObject);
begin
   close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
if form1.OpenDialog1.Execute  then begin
 form1.Edit1.Text:=form1.OpenDialog1.filename;
 form1.Edit2.Text:=form1.Edit1.Text;
end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
if form1.SaveDialog1.Execute  then begin
 form1.Edit2.Text:=FORM1.SaveDialog1.FileName;
end;

end;

function DosToWin(St: string): string; //  Dos  Win 
var
  Ch: PChar;
begin
  Ch := StrAlloc(Length(St) + 1);
  OemToAnsi(PChar(St), Ch);
  Result := Ch;
  StrDispose(Ch)
end;

Function WinToDos(const S: string):string;
var
  NewStr: string;
begin
  SetLength(NewStr, Length(S));
  Windows.CharToOem(PChar(S), PChar(NewStr));
  result:=NewStr;
end;

procedure TForm1.Button3Click(Sender: TObject);
var txt:TStringList;
begin
   txt:=TStringList.Create;
   txt.LoadFromFile(form1.Edit1.Text);
   txt.Text:=wintodos(txt.Text);
   txt.SaveToFile(form1.Edit2.Text);
   txt.Free;
end;




procedure TForm1.Button5Click(Sender: TObject);
var txt:TStringList;
begin
   txt:=TStringList.Create;
   txt.LoadFromFile(form1.Edit1.Text);
   txt.Text:=DosToWin(txt.Text);
   txt.SaveToFile(form1.Edit2.Text);
   txt.Free;
end;

procedure CvWinToDos(Fl1,fl2:string);
var
  Txt:TStringList;
  begin
      txt:=TStringList.Create;
      txt.LoadFromFile(Fl1);
      txt.Text:=WinToDos(txt.Text);
      txt.SaveToFile(Fl2);
      txt.Free;
  end;

procedure CvDosToWin(Fl1,fl2:string);
var
  Txt:TStringList;
  begin
      txt:=TStringList.Create;
      txt.LoadFromFile(Fl1);
      txt.Text:=DoSToWin(txt.Text);
      txt.SaveToFile(Fl2);
      txt.Free;
  end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
if Fileage(form1.Edit1.Text)>-1 then begin
  form1.Button3.Enabled:=true;
  form1.Button5.Enabled:=true;
end else
begin
  form1.Button3.Enabled:=false;
  form1.Button5.Enabled:=false;

end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   Edit1Change(nil);
   Button7Click(nil);
end;

procedure TForm1.DirectoryListBox1Change(Sender: TObject);
begin
edit6.Text:=form1.DirectoryListBox1.Directory;
if edit3.Text='' then

end;


function SelectDirCB(Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM): Integer stdcall;
begin
  if (uMsg = BFFM_INITIALIZED) and (lpData <> 0) then
    SendMessage(Wnd, BFFM_SETSELECTION, Integer(True), lpdata);
  result := 0;
end;

function SelectDirectory(const Caption: string; const Root: WideString;
  var Directory: string): Boolean;
  const
 BIF_USENEWUI = $0040;
 BIF_NOCREATEDIRS = $0200;
var
  WindowList: Pointer;
  BrowseInfo: TBrowseInfo;
  Buffer: PChar;
  OldErrorMode: Cardinal;
  RootItemIDList, ItemIDList: PItemIDList;
  ShellMalloc: IMalloc;
  IDesktopFolder: IShellFolder;
  Eaten, Flags: LongWord;
begin
  Result := False;
  if not DirectoryExists(Directory) then
    Directory := '';
  FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
  if (ShGetMalloc(ShellMalloc) = S_OK) and (ShellMalloc <> nil) then
  begin
    Buffer := ShellMalloc.Alloc(MAX_PATH);
    try
      RootItemIDList := nil;
      if Root <> '' then
      begin
        SHGetDesktopFolder(IDesktopFolder);
        IDesktopFolder.ParseDisplayName(Application.Handle, nil,
          POleStr(Root), Eaten, RootItemIDList, Flags);
      end;
      with BrowseInfo do
      begin
        hwndOwner := Application.Handle;
        pidlRoot := RootItemIDList;
        pszDisplayName := Buffer;
        lpszTitle := PChar(Caption);
        ulFlags :=
         BIF_RETURNONLYFSDIRS or
         BIF_USENEWUI or
         BIF_EDITBOX * Ord(1) or
         BIF_BROWSEINCLUDEFILES * Ord(0) or
         BIF_NOCREATEDIRS * Ord(true);

        if Directory <> '' then
        begin
          lpfn := SelectDirCB;
          lParam := Integer(PChar(Directory));
        end;
      end;
      WindowList := DisableTaskWindows(0);
      OldErrorMode := SetErrorMode(SEM_FAILCRITICALERRORS);
      try
        ItemIDList := ShBrowseForFolder(BrowseInfo);
      finally
        SetErrorMode(OldErrorMode);
        EnableTaskWindows(WindowList);
      end;
      Result :=  ItemIDList <> nil;
      if Result then
      begin
        ShGetPathFromIDList(ItemIDList, Buffer);
        ShellMalloc.Free(ItemIDList);
        Directory := Buffer;
      end;
    finally
      ShellMalloc.Free(Buffer);
    end;
  end;
end;


procedure TForm1.Button6Click(Sender: TObject);
var dir:string;
begin
    dir:=form1.Edit3.Text;
    SelectDirectory('','',dir);
    form1.Edit3.Text:=dir;

end;



procedure TForm1.Button7Click(Sender: TObject);
begin
    edit3.Text:=form1.DirectoryListBox1.Directory;
end;


 function ExtractOnlyFileName(const FileName: string): string;

 begin

   result:=StringReplace(ExtractFileName(FileName),ExtractFileExt(FileName),'',[]);

 end;



procedure TForm1.Button8Click(Sender: TObject);
var x:integer;
    flname_mask,flname,fl1,fl2:string;
begin

  for X:=0 to form1.FileListBox3.Items.Count-1 do begin
   if (form1.FileListBox3.Selected[x]) or (form1.FileListBox3.SelCount=0) then begin

      fl1:=form1.DirectoryListBox1.Directory+'\'+form1.FileListBox3.Items[x];
      flname:=ExtractOnlyFileName(form1.FileListBox3.Items[x]);
      flname_mask:=ExtractFileExt(form1.FileListBox3.Items[x]);
      if form1.CheckBox1.Checked then  flname:=flname+form1.Edit4.Text;
      if form1.CheckBox2.Checked then  flname_mask:='.'+form1.Edit5.Text;

      fl2:=form1.Edit3.Text+'\'+flname+flname_mask;

      CvWinToDos(fl1,fl2);
     end;

  end;
end;

procedure TForm1.Edit6KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=13 then begin
  form1.FileListBox3.Directory:=edit6.Text;
  end;
end;

procedure TForm1.Button9Click(Sender: TObject);
var x:integer;
    flname_mask,flname,fl1,fl2:string;
begin

  for X:=0 to form1.FileListBox3.Items.Count-1 do begin
   if (form1.FileListBox3.Selected[x]) or (form1.FileListBox3.SelCount=0) then begin

      fl1:=form1.DirectoryListBox1.Directory+'\'+form1.FileListBox3.Items[x];
      flname:=ExtractOnlyFileName(form1.FileListBox3.Items[x]);
      flname_mask:=ExtractFileExt(form1.FileListBox3.Items[x]);
      if form1.CheckBox1.Checked then  flname:=flname+form1.Edit4.Text;
      if form1.CheckBox2.Checked then  flname_mask:='.'+form1.Edit5.Text;

      fl2:=form1.Edit3.Text+'\'+flname+flname_mask;

      CvWinToDos(fl1,fl2);
     end;

  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
form1.WebBrowser1.Navigate('http://netsoftware.ucoz.ru/');
end;

end.
